/*
 * ICollabView.java
 *
 * Created on December 5, 2002, 2:19 AM
 */

package CollabUtils;



/** Common View interface for Project 4 Viewers
 *
 */
public interface ICollabView {
    
    /** Requests the view to be redrawn.
     * In the case of a GUI component, this might reduce to a one-line call
     * to repaint().
     * In the case of a console view, the method should take into account the
     * fact that other components may be displaying message on the console.
     * It would be advisable to mark view messages in some way.
     */
    void reDrawView();
    
    /** Signals that no further viewing will be demanded.
     * The viewer is free to clean up or terminate.
     */
    void terminateView();

    
// end ICollabView   
}
